//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed
#property indicator_color3 DeepSkyBlue
#property indicator_color4 PaleVioletRed
#property indicator_width3 2
#property indicator_width4 2

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    Price            = 0;
extern int    MaLength         = 14;
extern int    AtrLength        = 5;
extern int    Ma_Mode          = MODE_EMA; 
extern double Multiplier       = 2;  
extern double MoneyRisk        = 1; 
extern bool   Interpolate      = true; 
extern bool   ShowArrow        = true;

extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

extern bool   ShowRisk         = true;  
extern string uniqueIdentifier = "atr stop1";
extern color  LabelsColorUp    = DeepSkyBlue;
extern color  LabelsColorDn    = PaleVioletRed;
extern int    labelFontSize    = 8;

//
//
//
//
//

double UpLine[];
double DnLine[]; 
double UpArrow[];
double DnArrow[]; 
double smax[];
double smin[];
double atr[];
double trend[];
double temp[];
double _Point = 1;

//
//
//
//
//

string indicatorFileName;
string shortName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,UpLine);  
      SetIndexBuffer(1,DnLine);  
      SetIndexBuffer(2,UpArrow); 
      SetIndexBuffer(3,DnArrow); 
      SetIndexBuffer(4,smax);
      SetIndexBuffer(5,smin);
      SetIndexBuffer(6,atr);
      SetIndexBuffer(7,trend);
      
      if(ShowArrow)
      {
      
      SetIndexStyle(0,DRAW_ARROW);SetIndexArrow(0,159);
      SetIndexStyle(1,DRAW_ARROW);SetIndexArrow(1,159);
      
      }
      else
      {
      
      SetIndexStyle(0,DRAW_LINE);
      SetIndexStyle(1,DRAW_LINE);
      
      }
      SetIndexStyle(2,DRAW_ARROW);SetIndexArrow(2,225);
      SetIndexStyle(3,DRAW_ARROW);SetIndexArrow(3,226);
      
      //
      //
      // 
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      _Point            =  MarketInfo(Symbol(),MODE_POINT)*MathPow(10,Digits%2);
      
      //
      //
      //
      //
      //
      
      IndicatorDigits(5);
      shortName = uniqueIdentifier+": "+timeFrameToString(timeFrame)+" ATR Stop Loss";
      IndicatorShortName(shortName); 
  return(0);
}

//
//
//
//
//

int deinit(){  if (!calculateValue && ShowRisk) deleteLabels();  return(0); }

      
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArraySize(temp)!=Bars) ArrayResize(temp,Bars);
         if (returnBars) { UpLine[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   { 
      if (TimeDayOfWeek(iTime(NULL,PERIOD_D1,i))==0)
      {
         temp[r] = MathMax(High[r+i+1],Close[r+i+2])-MathMin(Low[r+i+1],Close[r+i+2]);
      }
      else
      {
         temp[r] = MathMax(High[r+i],Close[r+i+1])-MathMin(Low[r+i],Close[r+i+1]);
      }
      
   }
   
   //
   //
   //
   //
   //
      
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {  
         atr[i]=iMAOnArray(temp[r],Bars,AtrLength,0,Ma_Mode,i);
         
         if(Price==2 || Price==3)
         {
         double bprice = iMA(NULL,0,MaLength,0,MODE_SMA,PRICE_HIGH,i);
         double sprice = iMA(NULL,0,MaLength,0,MODE_SMA,PRICE_LOW, i);
         }
         else
         {
         bprice = iMA(NULL,0,MaLength,0,MODE_SMA,Price,i);
         sprice = iMA(NULL,0,MaLength,0,MODE_SMA,Price,i);
         }
         
         smin[i]    = sprice - Multiplier * atr[i]; 
	      smax[i]    = bprice + Multiplier * atr[i]; 
         UpLine[i]  = EMPTY_VALUE;
         DnLine[i]  = EMPTY_VALUE;
         UpArrow[i] = EMPTY_VALUE;
         DnArrow[i] = EMPTY_VALUE;
         trend[i]   = trend[i+1]; 
   
         //
         //
         //
         //
         //
         
	      if (bprice > smax[i+1]) trend[i] =  1;
         if (sprice < smin[i+1]) trend[i] = -1;
	      if (trend[i] > 0 && smin[i] < smin[i+1]) smin[i] = smin[i+1];
	      if (trend[i] < 0 && smax[i] > smax[i+1]) smax[i] = smax[i+1];
         if (trend[i] == 1)
            {  
               UpLine[i] = smin[i] - (MoneyRisk - 1) * atr[i]; if (trend[i+1]!= 1) UpArrow[i] = UpLine[i];
            }
         if (trend[i] ==-1)
            {  
               DnLine[i] = smax[i] + (MoneyRisk - 1) * atr[i]; if (trend[i+1]!=-1) DnArrow[i] = DnLine[i];
            }
               if (!calculateValue) manageLabel(i);
      }
    
      manageAlerts();
      return(0);
      }
      
      //
      //
      //
      //
      //
   
      limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      { 
      
      int y = iBarShift(NULL,timeFrame,Time[i]);
         UpLine[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,MaLength,AtrLength,Ma_Mode,Multiplier,MoneyRisk,0,y);
         DnLine[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,MaLength,AtrLength,Ma_Mode,Multiplier,MoneyRisk,1,y);
         trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,MaLength,AtrLength,Ma_Mode,Multiplier,MoneyRisk,7,y);
         UpArrow[i] = EMPTY_VALUE;
         DnArrow[i] = EMPTY_VALUE;
            if (UpLine[i]!= EMPTY_VALUE && UpLine[i+1]==EMPTY_VALUE) UpArrow[i]=UpLine[i];
            if (DnLine[i]!= EMPTY_VALUE && DnLine[i+1]==EMPTY_VALUE) DnArrow[i]=DnLine[i];
            
            manageLabel(i);
               
         //
         //
         //
         //
         //
                        
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(int k = 1; k < n; k++)
            {
               if (UpLine[i]!=EMPTY_VALUE && UpLine[i+n]!=EMPTY_VALUE) UpLine[i+k] = UpLine[i] + (UpLine[i+n]-UpLine[i])*k/n;
               if (DnLine[i]!=EMPTY_VALUE && DnLine[i+n]!=EMPTY_VALUE) DnLine[i+k] = DnLine[i] + (DnLine[i+n]-DnLine[i])*k/n;
   
            }
    
   }
   
   manageAlerts();  
   return(0);         
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (! calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Atr Stop ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Atr Stop "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

void manageLabel(int i)
{
   int window = WindowFind(shortName);
   if (ShowRisk)
   {
      deleteLabel(Time[i]);

   //
   //
   //
   //
   //
   
   if (trend[i] == 1)
   {     
      string name = uniqueIdentifier+":"+"HPT - Risk " + Period() + " - Prev. ATR Risk";
            if(ObjectFind(name)  == -1)
              ObjectCreate(name, OBJ_LABEL,0,EMPTY_VALUE,EMPTY_VALUE);
                 ObjectSet(name, OBJPROP_XDISTANCE, 2);
                 ObjectSet(name, OBJPROP_YDISTANCE, 2);
                 ObjectSet(name, OBJPROP_CORNER,    1);
                 ObjectSetText(name, "Prev. ATR Risk = " + DoubleToStr(MathAbs(UpLine[1] - Close[1])/_Point,0),labelFontSize,"Arial Black",LabelsColorUp);
      
      //
      //
      //
      //
      //
      
         name = uniqueIdentifier+":"+"HPT - Risk " + Period() + " - Prev. ATR Price";
            if(ObjectFind(name)  == -1)
              ObjectCreate(name, OBJ_LABEL,0,EMPTY_VALUE,EMPTY_VALUE); 
                 ObjectSet(name, OBJPROP_XDISTANCE, 2);
                 ObjectSet(name, OBJPROP_YDISTANCE,15);
                 ObjectSet(name, OBJPROP_CORNER,    1);
                 ObjectSetText(name, "Prev. ATR Price = " + DoubleToStr(UpLine[1],Digits),labelFontSize,"Arial Black",LabelsColorUp);
      
      //
      //
      //
      //
      //
      
         name = uniqueIdentifier+":"+"HPT - Risk " + Period() + " - Cur. ATR Risk";
            if(ObjectFind(name)  == -1)
              ObjectCreate(name, OBJ_LABEL,0,EMPTY_VALUE,EMPTY_VALUE); 
                 ObjectSet(name, OBJPROP_XDISTANCE, 2);
                 ObjectSet(name, OBJPROP_YDISTANCE,28);
                 ObjectSet(name, OBJPROP_CORNER,    1);
                 ObjectSetText(name, "Cur. ATR Risk = " + DoubleToStr(MathAbs(UpLine[0] - Close[0])/_Point,0),labelFontSize,"Arial Black",LabelsColorUp);
      //
      //
      //
      //
      //
      
         name = uniqueIdentifier+":"+"HPT - Risk " + Period() + " - Cur. ATR Price";
            if(ObjectFind(name)  == -1)
              ObjectCreate(name, OBJ_LABEL,0,EMPTY_VALUE,EMPTY_VALUE);
                 ObjectSet(name, OBJPROP_XDISTANCE, 2);
                 ObjectSet(name, OBJPROP_YDISTANCE, 41);
                 ObjectSet(name, OBJPROP_CORNER, 1);   
                 ObjectSetText(name, "Cur. ATR Price = " + DoubleToStr(UpLine[0], Digits),labelFontSize,"Arial Black",LabelsColorUp);
         
     }
      
     if (trend[i] == -1)
     {     
         name = uniqueIdentifier+":"+"HPT - Risk " + Period() + " - Prev. ATR Risk";
            if(ObjectFind(name)  == -1)
              ObjectCreate(name, OBJ_LABEL,0,EMPTY_VALUE,EMPTY_VALUE); 
                 ObjectSet(name, OBJPROP_XDISTANCE, 2);
                 ObjectSet(name, OBJPROP_YDISTANCE, 2);
                 ObjectSet(name, OBJPROP_CORNER,    1);
                 ObjectSetText(name, "Prev. ATR Risk = " + DoubleToStr(MathAbs(DnLine[1] - Close[1])/_Point,0),labelFontSize,"Arial Black",LabelsColorDn);
      
      //
      //
      //
      //
      //
      
         name = uniqueIdentifier+":"+"HPT - Risk " + Period() + " - Prev. ATR Price";
            if(ObjectFind(name)  == -1)
              ObjectCreate(name, OBJ_LABEL,0,EMPTY_VALUE,EMPTY_VALUE); 
                 ObjectSet(name, OBJPROP_XDISTANCE, 2);
                 ObjectSet(name, OBJPROP_YDISTANCE,15);
                 ObjectSet(name, OBJPROP_CORNER,    1);
                 ObjectSetText(name, "Prev. ATR Price = " + DoubleToStr(DnLine[1], Digits),labelFontSize,"Arial Black",LabelsColorDn);
      
      //
      //
      //
      //
      //
      
         name = uniqueIdentifier+":"+"HPT - Risk " + Period() + " - Cur. ATR Risk";
            if(ObjectFind(name)  == -1)
              ObjectCreate(name, OBJ_LABEL,0,EMPTY_VALUE,EMPTY_VALUE);
                 ObjectSet(name, OBJPROP_XDISTANCE, 2);
                 ObjectSet(name, OBJPROP_YDISTANCE,28);
                 ObjectSet(name, OBJPROP_CORNER,    1);
                 ObjectSetText(name, "Cur. ATR Risk = " + DoubleToStr(MathAbs(DnLine[0] - Close[0])/_Point,0),labelFontSize,"Arial Black",LabelsColorDn);
      //
      //
      //
      //
      //
      
         name = uniqueIdentifier+":"+"HPT - Risk " + Period() + " - Cur. ATR Price";
            if(ObjectFind(name)  == -1)
              ObjectCreate(name, OBJ_LABEL,0,EMPTY_VALUE,EMPTY_VALUE);
                 ObjectSet(name, OBJPROP_XDISTANCE, 2);
                 ObjectSet(name, OBJPROP_YDISTANCE, 41);
                 ObjectSet(name, OBJPROP_CORNER, 1);   
                 ObjectSetText(name, "Cur. ATR Price = " + DoubleToStr(DnLine[0],Digits),labelFontSize,"Arial Black",LabelsColorDn);
         
      }
   }
   
}

//+------------------------------------------------------------------+
//
//
//
//
//

void deleteLabels()
{
   string lookFor       = uniqueIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteLabel(datetime time)
{
   string lookFor = uniqueIdentifier+":"+time; ObjectDelete(lookFor);
}

//
//
//
//
//

